git-am.shon commit send-email: improve RFC2047 quote parsing (b622d4d)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005, 2006 Junio C Hamano
   4
   5SUBDIRECTORY_OK=Yes
   6OPTIONS_KEEPDASHDASH=
   7OPTIONS_SPEC="\
   8git am [options] [(<mbox>|<Maildir>)...]
   9git am [options] (--resolved | --skip | --abort)
  10--
  11i,interactive   run interactively
  12b,binary*       (historical option -- no-op)
  133,3way          allow fall back on 3way merging if needed
  14q,quiet         be quiet
  15s,signoff       add a Signed-off-by line to the commit message
  16u,utf8          recode into utf8 (default)
  17k,keep          pass -k flag to git-mailinfo
  18keep-cr         pass --keep-cr flag to git-mailsplit for mbox format
  19no-keep-cr      do not pass --keep-cr flag to git-mailsplit independent of am.keepcr
  20c,scissors      strip everything before a scissors line
  21whitespace=     pass it through git-apply
  22ignore-space-change pass it through git-apply
  23ignore-whitespace pass it through git-apply
  24directory=      pass it through git-apply
  25exclude=        pass it through git-apply
  26C=              pass it through git-apply
  27p=              pass it through git-apply
  28patch-format=   format the patch(es) are in
  29reject          pass it through git-apply
  30resolvemsg=     override error message when patch failure occurs
  31continue        continue applying patches after resolving a conflict
  32r,resolved      synonyms for --continue
  33skip            skip the current patch
  34abort           restore the original branch and abort the patching operation.
  35committer-date-is-author-date    lie about committer date
  36ignore-date     use current timestamp for author date
  37rerere-autoupdate update the index with reused conflict resolution if possible
  38rebasing*       (internal use for git-rebase)"
  39
  40. git-sh-setup
  41. git-sh-i18n
  42prefix=$(git rev-parse --show-prefix)
  43set_reflog_action am
  44require_work_tree
  45cd_to_toplevel
  46
  47git var GIT_COMMITTER_IDENT >/dev/null ||
  48        die "$(gettext "You need to set your committer info first")"
  49
  50if git rev-parse --verify -q HEAD >/dev/null
  51then
  52        HAS_HEAD=yes
  53else
  54        HAS_HEAD=
  55fi
  56
  57cmdline="git am"
  58if test '' != "$interactive"
  59then
  60        cmdline="$cmdline -i"
  61fi
  62if test '' != "$threeway"
  63then
  64        cmdline="$cmdline -3"
  65fi
  66
  67sq () {
  68        git rev-parse --sq-quote "$@"
  69}
  70
  71stop_here () {
  72    echo "$1" >"$dotest/next"
  73    git rev-parse --verify -q HEAD >"$dotest/abort-safety"
  74    exit 1
  75}
  76
  77safe_to_abort () {
  78        if test -f "$dotest/dirtyindex"
  79        then
  80                return 1
  81        fi
  82
  83        if ! test -s "$dotest/abort-safety"
  84        then
  85                return 0
  86        fi
  87
  88        abort_safety=$(cat "$dotest/abort-safety")
  89        if test "z$(git rev-parse --verify -q HEAD)" = "z$abort_safety"
  90        then
  91                return 0
  92        fi
  93                gettextln "You seem to have moved HEAD since the last 'am' failure.
  94Not rewinding to ORIG_HEAD" >&2
  95        return 1
  96}
  97
  98stop_here_user_resolve () {
  99    if [ -n "$resolvemsg" ]; then
 100            printf '%s\n' "$resolvemsg"
 101            stop_here $1
 102    fi
 103    eval_gettextln "When you have resolved this problem run \"\$cmdline --resolved\".
 104If you would prefer to skip this patch, instead run \"\$cmdline --skip\".
 105To restore the original branch and stop patching run \"\$cmdline --abort\"."
 106
 107    stop_here $1
 108}
 109
 110go_next () {
 111        rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
 112                "$dotest/patch" "$dotest/info"
 113        echo "$next" >"$dotest/next"
 114        this=$next
 115}
 116
 117cannot_fallback () {
 118        echo "$1"
 119        gettextln "Cannot fall back to three-way merge."
 120        exit 1
 121}
 122
 123fall_back_3way () {
 124    O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
 125
 126    rm -fr "$dotest"/patch-merge-*
 127    mkdir "$dotest/patch-merge-tmp-dir"
 128
 129    # First see if the patch records the index info that we can use.
 130    cmd="git apply $git_apply_opt --build-fake-ancestor" &&
 131    cmd="$cmd "'"$dotest/patch-merge-tmp-index" "$dotest/patch"' &&
 132    eval "$cmd" &&
 133    GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
 134    git write-tree >"$dotest/patch-merge-base+" ||
 135    cannot_fallback "$(gettext "Repository lacks necessary blobs to fall back on 3-way merge.")"
 136
 137    say Using index info to reconstruct a base tree...
 138
 139    cmd='GIT_INDEX_FILE="$dotest/patch-merge-tmp-index"'
 140    cmd="$cmd git apply --cached $git_apply_opt"' <"$dotest/patch"'
 141    if eval "$cmd"
 142    then
 143        mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
 144        mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
 145    else
 146        cannot_fallback "$(gettext "Did you hand edit your patch?
 147It does not apply to blobs recorded in its index.")"
 148    fi
 149
 150    test -f "$dotest/patch-merge-index" &&
 151    his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git write-tree) &&
 152    orig_tree=$(cat "$dotest/patch-merge-base") &&
 153    rm -fr "$dotest"/patch-merge-* || exit 1
 154
 155    say "$(gettext "Falling back to patching base and 3-way merge...")"
 156
 157    # This is not so wrong.  Depending on which base we picked,
 158    # orig_tree may be wildly different from ours, but his_tree
 159    # has the same set of wildly different changes in parts the
 160    # patch did not touch, so recursive ends up canceling them,
 161    # saying that we reverted all those changes.
 162
 163    eval GITHEAD_$his_tree='"$FIRSTLINE"'
 164    export GITHEAD_$his_tree
 165    if test -n "$GIT_QUIET"
 166    then
 167            GIT_MERGE_VERBOSITY=0 && export GIT_MERGE_VERBOSITY
 168    fi
 169    git-merge-recursive $orig_tree -- HEAD $his_tree || {
 170            git rerere $allow_rerere_autoupdate
 171            echo Failed to merge in the changes.
 172            exit 1
 173    }
 174    unset GITHEAD_$his_tree
 175}
 176
 177clean_abort () {
 178        test $# = 0 || echo >&2 "$@"
 179        rm -fr "$dotest"
 180        exit 1
 181}
 182
 183patch_format=
 184
 185check_patch_format () {
 186        # early return if patch_format was set from the command line
 187        if test -n "$patch_format"
 188        then
 189                return 0
 190        fi
 191
 192        # we default to mbox format if input is from stdin and for
 193        # directories
 194        if test $# = 0 || test "x$1" = "x-" || test -d "$1"
 195        then
 196                patch_format=mbox
 197                return 0
 198        fi
 199
 200        # otherwise, check the first few non-blank lines of the first
 201        # patch to try to detect its format
 202        {
 203                # Start from first line containing non-whitespace
 204                l1=
 205                while test -z "$l1"
 206                do
 207                        read l1 || break
 208                done
 209                read l2
 210                read l3
 211                case "$l1" in
 212                "From "* | "From: "*)
 213                        patch_format=mbox
 214                        ;;
 215                '# This series applies on GIT commit'*)
 216                        patch_format=stgit-series
 217                        ;;
 218                "# HG changeset patch")
 219                        patch_format=hg
 220                        ;;
 221                *)
 222                        # if the second line is empty and the third is
 223                        # a From, Author or Date entry, this is very
 224                        # likely an StGIT patch
 225                        case "$l2,$l3" in
 226                        ,"From: "* | ,"Author: "* | ,"Date: "*)
 227                                patch_format=stgit
 228                                ;;
 229                        *)
 230                                ;;
 231                        esac
 232                        ;;
 233                esac
 234                if test -z "$patch_format" &&
 235                        test -n "$l1" &&
 236                        test -n "$l2" &&
 237                        test -n "$l3"
 238                then
 239                        # This begins with three non-empty lines.  Is this a
 240                        # piece of e-mail a-la RFC2822?  Grab all the headers,
 241                        # discarding the indented remainder of folded lines,
 242                        # and see if it looks like that they all begin with the
 243                        # header field names...
 244                        tr -d '\015' <"$1" |
 245                        sed -n -e '/^$/q' -e '/^[       ]/d' -e p |
 246                        sane_egrep -v '^[!-9;-~]+:' >/dev/null ||
 247                        patch_format=mbox
 248                fi
 249        } < "$1" || clean_abort
 250}
 251
 252split_patches () {
 253        case "$patch_format" in
 254        mbox)
 255                if test -n "$rebasing" || test t = "$keepcr"
 256                then
 257                    keep_cr=--keep-cr
 258                else
 259                    keep_cr=
 260                fi
 261                git mailsplit -d"$prec" -o"$dotest" -b $keep_cr -- "$@" > "$dotest/last" ||
 262                clean_abort
 263                ;;
 264        stgit-series)
 265                if test $# -ne 1
 266                then
 267                        clean_abort "$(gettext "Only one StGIT patch series can be applied at once")"
 268                fi
 269                series_dir=`dirname "$1"`
 270                series_file="$1"
 271                shift
 272                {
 273                        set x
 274                        while read filename
 275                        do
 276                                set "$@" "$series_dir/$filename"
 277                        done
 278                        # remove the safety x
 279                        shift
 280                        # remove the arg coming from the first-line comment
 281                        shift
 282                } < "$series_file" || clean_abort
 283                # set the patch format appropriately
 284                patch_format=stgit
 285                # now handle the actual StGIT patches
 286                split_patches "$@"
 287                ;;
 288        stgit)
 289                this=0
 290                for stgit in "$@"
 291                do
 292                        this=`expr "$this" + 1`
 293                        msgnum=`printf "%0${prec}d" $this`
 294                        # Perl version of StGIT parse_patch. The first nonemptyline
 295                        # not starting with Author, From or Date is the
 296                        # subject, and the body starts with the next nonempty
 297                        # line not starting with Author, From or Date
 298                        perl -ne 'BEGIN { $subject = 0 }
 299                                if ($subject > 1) { print ; }
 300                                elsif (/^\s+$/) { next ; }
 301                                elsif (/^Author:/) { s/Author/From/ ; print ;}
 302                                elsif (/^(From|Date)/) { print ; }
 303                                elsif ($subject) {
 304                                        $subject = 2 ;
 305                                        print "\n" ;
 306                                        print ;
 307                                } else {
 308                                        print "Subject: ", $_ ;
 309                                        $subject = 1;
 310                                }
 311                        ' < "$stgit" > "$dotest/$msgnum" || clean_abort
 312                done
 313                echo "$this" > "$dotest/last"
 314                this=
 315                msgnum=
 316                ;;
 317        hg)
 318                this=0
 319                for hg in "$@"
 320                do
 321                        this=$(( $this + 1 ))
 322                        msgnum=$(printf "%0${prec}d" $this)
 323                        # hg stores changeset metadata in #-commented lines preceding
 324                        # the commit message and diff(s). The only metadata we care about
 325                        # are the User and Date (Node ID and Parent are hashes which are
 326                        # only relevant to the hg repository and thus not useful to us)
 327                        # Since we cannot guarantee that the commit message is in
 328                        # git-friendly format, we put no Subject: line and just consume
 329                        # all of the message as the body
 330                        perl -M'POSIX qw(strftime)' -ne 'BEGIN { $subject = 0 }
 331                                if ($subject) { print ; }
 332                                elsif (/^\# User /) { s/\# User/From:/ ; print ; }
 333                                elsif (/^\# Date /) {
 334                                        my ($hashsign, $str, $time, $tz) = split ;
 335                                        $tz = sprintf "%+05d", (0-$tz)/36;
 336                                        print "Date: " .
 337                                              strftime("%a, %d %b %Y %H:%M:%S ",
 338                                                       localtime($time))
 339                                              . "$tz\n";
 340                                } elsif (/^\# /) { next ; }
 341                                else {
 342                                        print "\n", $_ ;
 343                                        $subject = 1;
 344                                }
 345                        ' <"$hg" >"$dotest/$msgnum" || clean_abort
 346                done
 347                echo "$this" >"$dotest/last"
 348                this=
 349                msgnum=
 350                ;;
 351        *)
 352                if test -n "$patch_format"
 353                then
 354                        clean_abort "$(eval_gettext "Patch format \$patch_format is not supported.")"
 355                else
 356                        clean_abort "$(gettext "Patch format detection failed.")"
 357                fi
 358                ;;
 359        esac
 360}
 361
 362prec=4
 363dotest="$GIT_DIR/rebase-apply"
 364sign= utf8=t keep= keepcr= skip= interactive= resolved= rebasing= abort=
 365resolvemsg= resume= scissors= no_inbody_headers=
 366git_apply_opt=
 367committer_date_is_author_date=
 368ignore_date=
 369allow_rerere_autoupdate=
 370
 371if test "$(git config --bool --get am.keepcr)" = true
 372then
 373    keepcr=t
 374fi
 375
 376while test $# != 0
 377do
 378        case "$1" in
 379        -i|--interactive)
 380                interactive=t ;;
 381        -b|--binary)
 382                : ;;
 383        -3|--3way)
 384                threeway=t ;;
 385        -s|--signoff)
 386                sign=t ;;
 387        -u|--utf8)
 388                utf8=t ;; # this is now default
 389        --no-utf8)
 390                utf8= ;;
 391        -k|--keep)
 392                keep=t ;;
 393        -c|--scissors)
 394                scissors=t ;;
 395        --no-scissors)
 396                scissors=f ;;
 397        -r|--resolved|--continue)
 398                resolved=t ;;
 399        --skip)
 400                skip=t ;;
 401        --abort)
 402                abort=t ;;
 403        --rebasing)
 404                rebasing=t threeway=t keep=t scissors=f no_inbody_headers=t ;;
 405        -d|--dotest)
 406                die "$(gettext "-d option is no longer supported.  Do not use.")"
 407                ;;
 408        --resolvemsg)
 409                shift; resolvemsg=$1 ;;
 410        --whitespace|--directory|--exclude)
 411                git_apply_opt="$git_apply_opt $(sq "$1=$2")"; shift ;;
 412        -C|-p)
 413                git_apply_opt="$git_apply_opt $(sq "$1$2")"; shift ;;
 414        --patch-format)
 415                shift ; patch_format="$1" ;;
 416        --reject|--ignore-whitespace|--ignore-space-change)
 417                git_apply_opt="$git_apply_opt $1" ;;
 418        --committer-date-is-author-date)
 419                committer_date_is_author_date=t ;;
 420        --ignore-date)
 421                ignore_date=t ;;
 422        --rerere-autoupdate|--no-rerere-autoupdate)
 423                allow_rerere_autoupdate="$1" ;;
 424        -q|--quiet)
 425                GIT_QUIET=t ;;
 426        --keep-cr)
 427                keepcr=t ;;
 428        --no-keep-cr)
 429                keepcr=f ;;
 430        --)
 431                shift; break ;;
 432        *)
 433                usage ;;
 434        esac
 435        shift
 436done
 437
 438# If the dotest directory exists, but we have finished applying all the
 439# patches in them, clear it out.
 440if test -d "$dotest" &&
 441   last=$(cat "$dotest/last") &&
 442   next=$(cat "$dotest/next") &&
 443   test $# != 0 &&
 444   test "$next" -gt "$last"
 445then
 446   rm -fr "$dotest"
 447fi
 448
 449if test -d "$dotest"
 450then
 451        case "$#,$skip$resolved$abort" in
 452        0,*t*)
 453                # Explicit resume command and we do not have file, so
 454                # we are happy.
 455                : ;;
 456        0,)
 457                # No file input but without resume parameters; catch
 458                # user error to feed us a patch from standard input
 459                # when there is already $dotest.  This is somewhat
 460                # unreliable -- stdin could be /dev/null for example
 461                # and the caller did not intend to feed us a patch but
 462                # wanted to continue unattended.
 463                test -t 0
 464                ;;
 465        *)
 466                false
 467                ;;
 468        esac ||
 469        die "$(eval_gettext "previous rebase directory \$dotest still exists but mbox given.")"
 470        resume=yes
 471
 472        case "$skip,$abort" in
 473        t,t)
 474                die "$(gettext "Please make up your mind. --skip or --abort?")"
 475                ;;
 476        t,)
 477                git rerere clear
 478                git read-tree --reset -u HEAD HEAD
 479                orig_head=$(cat "$GIT_DIR/ORIG_HEAD")
 480                git reset HEAD
 481                git update-ref ORIG_HEAD $orig_head
 482                ;;
 483        ,t)
 484                if test -f "$dotest/rebasing"
 485                then
 486                        exec git rebase --abort
 487                fi
 488                git rerere clear
 489                if safe_to_abort
 490                then
 491                        git read-tree --reset -u HEAD ORIG_HEAD
 492                        git reset ORIG_HEAD
 493                fi
 494                rm -fr "$dotest"
 495                exit ;;
 496        esac
 497        rm -f "$dotest/dirtyindex"
 498else
 499        # Make sure we are not given --skip, --resolved, nor --abort
 500        test "$skip$resolved$abort" = "" ||
 501                die "$(gettext "Resolve operation not in progress, we are not resuming.")"
 502
 503        # Start afresh.
 504        mkdir -p "$dotest" || exit
 505
 506        if test -n "$prefix" && test $# != 0
 507        then
 508                first=t
 509                for arg
 510                do
 511                        test -n "$first" && {
 512                                set x
 513                                first=
 514                        }
 515                        if is_absolute_path "$arg"
 516                        then
 517                                set "$@" "$arg"
 518                        else
 519                                set "$@" "$prefix$arg"
 520                        fi
 521                done
 522                shift
 523        fi
 524
 525        check_patch_format "$@"
 526
 527        split_patches "$@"
 528
 529        # -i can and must be given when resuming; everything
 530        # else is kept
 531        echo " $git_apply_opt" >"$dotest/apply-opt"
 532        echo "$threeway" >"$dotest/threeway"
 533        echo "$sign" >"$dotest/sign"
 534        echo "$utf8" >"$dotest/utf8"
 535        echo "$keep" >"$dotest/keep"
 536        echo "$scissors" >"$dotest/scissors"
 537        echo "$no_inbody_headers" >"$dotest/no_inbody_headers"
 538        echo "$GIT_QUIET" >"$dotest/quiet"
 539        echo 1 >"$dotest/next"
 540        if test -n "$rebasing"
 541        then
 542                : >"$dotest/rebasing"
 543        else
 544                : >"$dotest/applying"
 545                if test -n "$HAS_HEAD"
 546                then
 547                        git update-ref ORIG_HEAD HEAD
 548                else
 549                        git update-ref -d ORIG_HEAD >/dev/null 2>&1
 550                fi
 551        fi
 552fi
 553
 554git update-index -q --refresh
 555
 556case "$resolved" in
 557'')
 558        case "$HAS_HEAD" in
 559        '')
 560                files=$(git ls-files) ;;
 561        ?*)
 562                files=$(git diff-index --cached --name-only HEAD --) ;;
 563        esac || exit
 564        if test "$files"
 565        then
 566                test -n "$HAS_HEAD" && : >"$dotest/dirtyindex"
 567                die "$(eval_gettext "Dirty index: cannot apply patches (dirty: \$files)")"
 568        fi
 569esac
 570
 571if test "$(cat "$dotest/utf8")" = t
 572then
 573        utf8=-u
 574else
 575        utf8=-n
 576fi
 577if test "$(cat "$dotest/keep")" = t
 578then
 579        keep=-k
 580fi
 581case "$(cat "$dotest/scissors")" in
 582t)
 583        scissors=--scissors ;;
 584f)
 585        scissors=--no-scissors ;;
 586esac
 587if test "$(cat "$dotest/no_inbody_headers")" = t
 588then
 589        no_inbody_headers=--no-inbody-headers
 590else
 591        no_inbody_headers=
 592fi
 593if test "$(cat "$dotest/quiet")" = t
 594then
 595        GIT_QUIET=t
 596fi
 597if test "$(cat "$dotest/threeway")" = t
 598then
 599        threeway=t
 600fi
 601git_apply_opt=$(cat "$dotest/apply-opt")
 602if test "$(cat "$dotest/sign")" = t
 603then
 604        SIGNOFF=`git var GIT_COMMITTER_IDENT | sed -e '
 605                        s/>.*/>/
 606                        s/^/Signed-off-by: /'
 607                `
 608else
 609        SIGNOFF=
 610fi
 611
 612last=`cat "$dotest/last"`
 613this=`cat "$dotest/next"`
 614if test "$skip" = t
 615then
 616        this=`expr "$this" + 1`
 617        resume=
 618fi
 619
 620while test "$this" -le "$last"
 621do
 622        msgnum=`printf "%0${prec}d" $this`
 623        next=`expr "$this" + 1`
 624        test -f "$dotest/$msgnum" || {
 625                resume=
 626                go_next
 627                continue
 628        }
 629
 630        # If we are not resuming, parse and extract the patch information
 631        # into separate files:
 632        #  - info records the authorship and title
 633        #  - msg is the rest of commit log message
 634        #  - patch is the patch body.
 635        #
 636        # When we are resuming, these files are either already prepared
 637        # by the user, or the user can tell us to do so by --resolved flag.
 638        case "$resume" in
 639        '')
 640                git mailinfo $keep $no_inbody_headers $scissors $utf8 "$dotest/msg" "$dotest/patch" \
 641                        <"$dotest/$msgnum" >"$dotest/info" ||
 642                        stop_here $this
 643
 644                # skip pine's internal folder data
 645                sane_grep '^Author: Mail System Internal Data$' \
 646                        <"$dotest"/info >/dev/null &&
 647                        go_next && continue
 648
 649                test -s "$dotest/patch" || {
 650                        eval_gettextln "Patch is empty.  Was it split wrong?
 651If you would prefer to skip this patch, instead run \"\$cmdline --skip\".
 652To restore the original branch and stop patching run \"\$cmdline --abort\"."
 653                        stop_here $this
 654                }
 655                rm -f "$dotest/original-commit" "$dotest/author-script"
 656                if test -f "$dotest/rebasing" &&
 657                        commit=$(sed -e 's/^From \([0-9a-f]*\) .*/\1/' \
 658                                -e q "$dotest/$msgnum") &&
 659                        test "$(git cat-file -t "$commit")" = commit
 660                then
 661                        git cat-file commit "$commit" |
 662                        sed -e '1,/^$/d' >"$dotest/msg-clean"
 663                        echo "$commit" > "$dotest/original-commit"
 664                        get_author_ident_from_commit "$commit" > "$dotest/author-script"
 665                else
 666                        {
 667                                sed -n '/^Subject/ s/Subject: //p' "$dotest/info"
 668                                echo
 669                                cat "$dotest/msg"
 670                        } |
 671                        git stripspace > "$dotest/msg-clean"
 672                fi
 673                ;;
 674        esac
 675
 676        if test -f "$dotest/author-script"
 677        then
 678                eval $(cat "$dotest/author-script")
 679        else
 680                GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
 681                GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
 682                GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
 683        fi
 684
 685        if test -z "$GIT_AUTHOR_EMAIL"
 686        then
 687                gettextln "Patch does not have a valid e-mail address."
 688                stop_here $this
 689        fi
 690
 691        export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
 692
 693        case "$resume" in
 694        '')
 695            if test '' != "$SIGNOFF"
 696            then
 697                LAST_SIGNED_OFF_BY=`
 698                    sed -ne '/^Signed-off-by: /p' \
 699                    "$dotest/msg-clean" |
 700                    sed -ne '$p'
 701                `
 702                ADD_SIGNOFF=`
 703                    test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
 704                    test '' = "$LAST_SIGNED_OFF_BY" && echo
 705                    echo "$SIGNOFF"
 706                }`
 707            else
 708                ADD_SIGNOFF=
 709            fi
 710            {
 711                if test -s "$dotest/msg-clean"
 712                then
 713                        cat "$dotest/msg-clean"
 714                fi
 715                if test '' != "$ADD_SIGNOFF"
 716                then
 717                        echo "$ADD_SIGNOFF"
 718                fi
 719            } >"$dotest/final-commit"
 720            ;;
 721        *)
 722                case "$resolved$interactive" in
 723                tt)
 724                        # This is used only for interactive view option.
 725                        git diff-index -p --cached HEAD -- >"$dotest/patch"
 726                        ;;
 727                esac
 728        esac
 729
 730        resume=
 731        if test "$interactive" = t
 732        then
 733            test -t 0 ||
 734            die "$(gettext "cannot be interactive without stdin connected to a terminal.")"
 735            action=again
 736            while test "$action" = again
 737            do
 738                gettextln "Commit Body is:"
 739                echo "--------------------------"
 740                cat "$dotest/final-commit"
 741                echo "--------------------------"
 742                # TRANSLATORS: Make sure to include [y], [n], [e], [v] and [a]
 743                # in your translation. The program will only accept English
 744                # input at this point.
 745                gettext "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
 746                read reply
 747                case "$reply" in
 748                [yY]*) action=yes ;;
 749                [aA]*) action=yes interactive= ;;
 750                [nN]*) action=skip ;;
 751                [eE]*) git_editor "$dotest/final-commit"
 752                       action=again ;;
 753                [vV]*) action=again
 754                       git_pager "$dotest/patch" ;;
 755                *)     action=again ;;
 756                esac
 757            done
 758        else
 759            action=yes
 760        fi
 761
 762        if test -f "$dotest/final-commit"
 763        then
 764                FIRSTLINE=$(sed 1q "$dotest/final-commit")
 765        else
 766                FIRSTLINE=""
 767        fi
 768
 769        if test $action = skip
 770        then
 771                go_next
 772                continue
 773        fi
 774
 775        if test -x "$GIT_DIR"/hooks/applypatch-msg
 776        then
 777                "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
 778                stop_here $this
 779        fi
 780
 781        say "$(eval_gettext "Applying: \$FIRSTLINE")"
 782
 783        case "$resolved" in
 784        '')
 785                # When we are allowed to fall back to 3-way later, don't give
 786                # false errors during the initial attempt.
 787                squelch=
 788                if test "$threeway" = t
 789                then
 790                        squelch='>/dev/null 2>&1 '
 791                fi
 792                eval "git apply $squelch$git_apply_opt"' --index "$dotest/patch"'
 793                apply_status=$?
 794                ;;
 795        t)
 796                # Resolved means the user did all the hard work, and
 797                # we do not have to do any patch application.  Just
 798                # trust what the user has in the index file and the
 799                # working tree.
 800                resolved=
 801                git diff-index --quiet --cached HEAD -- && {
 802                        gettextln "No changes - did you forget to use 'git add'?
 803If there is nothing left to stage, chances are that something else
 804already introduced the same changes; you might want to skip this patch."
 805                        stop_here_user_resolve $this
 806                }
 807                unmerged=$(git ls-files -u)
 808                if test -n "$unmerged"
 809                then
 810                        gettextln "You still have unmerged paths in your index
 811did you forget to use 'git add'?"
 812                        stop_here_user_resolve $this
 813                fi
 814                apply_status=0
 815                git rerere
 816                ;;
 817        esac
 818
 819        if test $apply_status != 0 && test "$threeway" = t
 820        then
 821                if (fall_back_3way)
 822                then
 823                    # Applying the patch to an earlier tree and merging the
 824                    # result may have produced the same tree as ours.
 825                    git diff-index --quiet --cached HEAD -- && {
 826                        say "$(gettext "No changes -- Patch already applied.")"
 827                        go_next
 828                        continue
 829                    }
 830                    # clear apply_status -- we have successfully merged.
 831                    apply_status=0
 832                fi
 833        fi
 834        if test $apply_status != 0
 835        then
 836                eval_gettextln 'Patch failed at $msgnum $FIRSTLINE'
 837                stop_here_user_resolve $this
 838        fi
 839
 840        if test -x "$GIT_DIR"/hooks/pre-applypatch
 841        then
 842                "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
 843        fi
 844
 845        tree=$(git write-tree) &&
 846        commit=$(
 847                if test -n "$ignore_date"
 848                then
 849                        GIT_AUTHOR_DATE=
 850                fi
 851                parent=$(git rev-parse --verify -q HEAD) ||
 852                say >&2 "$(gettext "applying to an empty history")"
 853
 854                if test -n "$committer_date_is_author_date"
 855                then
 856                        GIT_COMMITTER_DATE="$GIT_AUTHOR_DATE"
 857                        export GIT_COMMITTER_DATE
 858                fi &&
 859                git commit-tree $tree ${parent:+-p} $parent <"$dotest/final-commit"
 860        ) &&
 861        git update-ref -m "$GIT_REFLOG_ACTION: $FIRSTLINE" HEAD $commit $parent ||
 862        stop_here $this
 863
 864        if test -f "$dotest/original-commit"; then
 865                echo "$(cat "$dotest/original-commit") $commit" >> "$dotest/rewritten"
 866        fi
 867
 868        if test -x "$GIT_DIR"/hooks/post-applypatch
 869        then
 870                "$GIT_DIR"/hooks/post-applypatch
 871        fi
 872
 873        go_next
 874done
 875
 876if test -s "$dotest"/rewritten; then
 877    git notes copy --for-rewrite=rebase < "$dotest"/rewritten
 878    if test -x "$GIT_DIR"/hooks/post-rewrite; then
 879        "$GIT_DIR"/hooks/post-rewrite rebase < "$dotest"/rewritten
 880    fi
 881fi
 882
 883rm -fr "$dotest"
 884git gc --auto